
c This is an example of calling the halo evolution subroutine mc2.f
c by Donghai Zhao on Sept. 14, 2010


      program callmc2
      implicit none

      integer*4 ihistory,ispec
      logical newcosmo
      real*8 zobs,lgMvir,cvir
      real*8 omegam0,omegaL0,omegab0,T_cmb,h,tilt,sigma8
      character myfile*50
      integer*4 i,j,nzout
      real*8 ziz,Miz,c


      ihistory=0
c-------------------------------------------------------------------------------

      newcosmo=.true.  ! required when set new cosmology or new power spectrum
      omegam0=0.3d0
      omegaL0=0.7d0                ! omegaL0 can be 1-omegam0 or 0
      ispec=2
      h=0.666667d0
      sigma8=0.90d0
      tilt=1.0d0


      print*, ' '
      print*, '-----------------------------------'
      write(*,*)'ispec= ',ispec
      print*, ' '

      do i=0,2
         zobs=0.0d0+i
         do j=0,2
            lgMvir=10.0d0+2.0d0*j
            call mc2(zobs,lgMvir,cvir,ihistory,newcosmo,ispec,
     &         omegam0,omegaL0,omegab0,T_cmb,h,tilt,sigma8,myfile)
            write(*,*)'zobs,lgMvir,cvir= ',zobs,lgMvir,cvir
            print*, ' '
         enddo
      enddo


c-------------------------------------------------------------------------------
      ihistory=1 ! ask the subroutine to output halo evolution history to a file

      newcosmo=.true.  ! required when set new cosmology or new power spectrum
      omegam0=0.258d0
      omegaL0=0.742d0              ! omegaL0 can be 1-omegam0 or 0
      ispec=1
      h=0.72d0
      sigma8=0.796d0
      tilt=0.963d0
      omegab0=0.0438d0
      T_cmb=2.726d0


      print*, ' '
      print*, '-----------------------------------'
      write(*,*)'ispec= ',ispec
      print*, ' '

      do i=2,0,-1
         zobs=0.0d0+i
         do j=2,0,-1
            lgMvir=10.0d0+2.0d0*j
            call mc2(zobs,lgMvir,cvir,ihistory,newcosmo,ispec,
     &         omegam0,omegaL0,omegab0,T_cmb,h,tilt,sigma8,myfile)
            write(*,*)'zobs,lgMvir,cvir= ',zobs,lgMvir,cvir
            print*, ' '
         enddo
      enddo

      print*, 'Please type 1 to output an example of evolution history.'
      read(*,*)j
      if(j.eq.1)then
         open(31,file='mchistory_dhzhao',status='old')
         read(31,*)nzout
         do i=0,nzout
            read(31,*)ziz,Miz,c
            write(*,*)'ziz,Miz,c= ',ziz,Miz,c
         enddo
         close(31)
      endif


      ihistory=0
c-------------------------------------------------------------------------------

c      newcosmo=.true.  ! required when set new cosmology or new power spectrum
c      omegam0=0.3d0
c      omegaL0=0.7d0                ! omegaL0 can be 1-omegam0 or 0
c      ispec=-1
c      myfile='mytransferfilename'  ! one may replace it with the real name
c      sigma8=0.90d0
c      tilt=1.0d0

c-------------------------------------------------------------------------------

c      newcosmo=.true.  ! required when set new cosmology or new power spectrum
c      omegam0=0.3d0
c      omegaL0=0.7d0                ! omegaL0 can be 1-omegam0 or 0
c      ispec=-2
c      myfile='myspectrumfilename'  ! one may replace it with the real name
c      sigma8=0.90d0

c-------------------------------------------------------------------------------

      newcosmo=.true.  ! required when set new cosmology or new power spectrum
      omegam0=1.0d0
      omegaL0=0.0d0                ! omegaL0 can be 1-omegam0 or 0
      ispec=0
      tilt=-0.5d0


      print*, ' '
      print*, '-----------------------------------'
      write(*,*)'ispec= ',ispec
      print*, ' '

      do i=0,2
         zobs=0.0d0+i
         do j=0,2
            lgMvir=-2.0d0+2.0d0*j  ! for ispec=0, in [M_star0], not [M_sun/h]
            call mc2(zobs,lgMvir,cvir,ihistory,newcosmo,ispec,
     &         omegam0,omegaL0,omegab0,T_cmb,h,tilt,sigma8,myfile)
            write(*,*)'zobs,lgMvir,cvir= ',zobs,lgMvir,cvir
            print*, ' '
         enddo
      enddo

c      print*, 'redshift   ?'
c      read(*,*)zobs
c      print*, 'lgMvir   ?'
c      read(*,*)lgMvir
c      call mc2(zobs,lgMvir,cvir,ihistory,newcosmo,ispec,
c     &   omegam0,omegaL0,omegab0,T_cmb,h,tilt,sigma8,myfile)
c      write(*,*)'zobs,lgMvir,cvir= ',zobs,lgMvir,cvir
c      print*, ' '


      end


